

.. index::
   pair: Nice doc; tortoise-orm


==============
tortoise-orm
==============

.. seealso::

   - https://tortoise-orm.readthedocs.io/en/latest/
   - https://github.com/tortoise/tortoise-orm



.. figure:: tortoise_orm.png
   :align: center


Fichier config.py
===================

.. seealso::

   - https://github.com/tortoise/tortoise-orm/blob/master/docs/conf.py


.. code-block:: python
   :linenos:


    # -*- coding: utf-8 -*-
    #
    # Configuration file for the Sphinx documentation builder.
    #
    # This file does only contain a selection of the most common options. For a
    # full list see the documentation:
    # http://www.sphinx-doc.org/en/stable/config

    # -- Path setup --------------------------------------------------------------

    # If extensions (or modules to document with autodoc) are in another directory,
    # add these directories to sys.path here. If the directory is relative to the
    # documentation root, use os.path.abspath to make it absolute, like shown here.
    #
    import os
    import re
    import sys
    sys.path.insert(0, os.path.abspath('.'))
    sys.path.insert(0, os.path.abspath('..'))

    from unittest.mock import MagicMock

    class Mock(MagicMock):
        @classmethod
        def __getattr__(cls, name):
            return MagicMock()

    MOCK_MODULES = ['aiosqlite', 'astroid', 'asyncpg', 'asynctest', 'aiomysql']
    sys.modules.update((mod_name, Mock()) for mod_name in MOCK_MODULES)


    # -- Project information -----------------------------------------------------


    project = 'Tortoise'
    copyright = '2018, Andrey Bondar'
    author = 'Andrey Bondar'


    def get_version():
        verstrline = open('../tortoise/__init__.py', "rt").read()
        mob = re.search(r"^__version__ = ['\"]([^'\"]*)['\"]", verstrline, re.M)
        if mob:
            return mob.group(1)
        else:
            raise RuntimeError("Unable to find version string")


    # The short X.Y version
    version = get_version()
    # The full version, including alpha/beta/rc tags
    release = version


    # -- General configuration ---------------------------------------------------

    # If your documentation needs a minimal Sphinx version, state it here.
    #
    # needs_sphinx = '1.0'

    # Add any Sphinx extension module names here, as strings. They can be
    # extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
    # ones.
    extensions = [
        'sphinx.ext.autodoc',
        'sphinx.ext.napoleon',
        'sphinx_autodoc_typehints',
        'sphinx.ext.todo',

        # cloud's extensions
        'cloud_sptheme.ext.autodoc_sections',
        'cloud_sptheme.ext.relbar_links',
        'cloud_sptheme.ext.escaped_samp_literals',
        'cloud_sptheme.ext.table_styling',
    ]

    # Add any paths that contain templates here, relative to this directory.
    templates_path = ['_templates']

    # The suffix(es) of source filenames.
    # You can specify multiple suffix as a list of string:
    #
    # source_suffix = ['.rst', '.md']
    source_suffix = '.rst'

    # The master toctree document.
    master_doc = 'toc'

    # The frontpage document.
    index_doc = 'index'

    # The language for content autogenerated by Sphinx. Refer to documentation
    # for a list of supported languages.
    #
    # This is also used if you do content translation via gettext catalogs.
    # Usually you set "language" from the command line for these cases.
    language = None

    # List of patterns, relative to source directory, that match files and
    # directories to ignore when looking for source files.
    # This pattern also affects html_static_path and html_extra_path .
    exclude_patterns = ['_build', 'Thumbs.db', '.DS_Store']

    # The name of the Pygments (syntax highlighting) style to use.
    pygments_style = 'sphinx'

    # Todo settings
    todo_include_todos = True
    todo_emit_warnings = True

    # Napoleon settings
    napoleon_google_docstring = False
    napoleon_numpy_docstring = True
    napoleon_include_init_with_doc = False
    napoleon_include_private_with_doc = False
    napoleon_include_special_with_doc = True
    napoleon_use_admonition_for_examples = True
    napoleon_use_admonition_for_notes = True
    napoleon_use_admonition_for_references = True
    napoleon_use_ivar = True
    napoleon_use_param = True
    napoleon_use_rtype = True

    # -- Options for HTML output -------------------------------------------------
    import cloud_sptheme as csp

    # The theme to use for HTML and HTML Help pages.  See the documentation for
    # a list of builtin themes.
    #
    html_theme = 'greencloud'

    # Theme options are theme-specific and customize the look and feel of a theme
    # further.  For a list of options available for each theme, see the
    # documentation.
    #
    html_theme_options = {
        'borderless_decor': True,
        'roottarget': index_doc,
        'sidebarwidth': '3in',
        'hyphenation_language': 'en',
    }

    # Add any paths that contain custom themes here, relative to this directory.
    html_theme_path = [csp.get_theme_dir()]

    # The name for this set of Sphinx documents.  If None, it defaults to
    # "<project> v<release> documentation".
    html_title = "%s v%s Documentation" % (project, release)

    # A shorter title for the navigation bar.  Default is the same as html_title.
    html_short_title = "%s %s Documentation" % (project, version)

    # The name of an image file (relative to this directory) to place at the top
    # of the sidebar.
    #
    html_logo = os.path.join("_static", "tortoise.png")

    # Add any paths that contain custom static files (such as style sheets) here,
    # relative to this directory. They are copied after the builtin static files,
    # so a file named "default.css" will overwrite the builtin "default.css".
    html_static_path = ['_static']

    # Custom sidebar templates, must be a dictionary that maps document names
    # to template names.
    #
    # The default sidebars (for documents that don't match any pattern) are
    # defined by theme itself.  Builtin themes are using these templates by
    # default: ``['localtoc.html', 'relations.html', 'sourcelink.html',
    # 'searchbox.html']``.
    #
    html_sidebars = {
        '**': [
            'searchbox.html',
            'space.html',
            'globaltoc.html',
        ]
    }


    # -- Options for HTMLHelp output ---------------------------------------------

    # Output file base name for HTML help builder.
    htmlhelp_basename = 'tortoisedoc'


    # -- Options for LaTeX output ------------------------------------------------

    latex_elements = {
        # The paper size ('letterpaper' or 'a4paper').
        #
        # 'papersize': 'letterpaper',

        # The font size ('10pt', '11pt' or '12pt').
        #
        # 'pointsize': '10pt',

        # Additional stuff for the LaTeX preamble.
        #
        # 'preamble': '',

        # Latex figure (float) alignment
        #
        # 'figure_align': 'htbp',
    }

    # Grouping the document tree into LaTeX files. List of tuples
    # (source start file, target name, title,
    #  author, documentclass [howto, manual, or own class]).
    latex_documents = [
        (master_doc, 'tortoise.tex', 'tortoise Documentation',
         'Andrey Bondar', 'manual'),
    ]


    # -- Options for manual page output ------------------------------------------

    # One entry per manual page. List of tuples
    # (source start file, name, description, authors, manual section).
    man_pages = [
        (master_doc, 'tortoise', 'tortoise Documentation',
         [author], 1)
    ]


    # -- Options for Texinfo output ----------------------------------------------

    # Grouping the document tree into Texinfo files. List of tuples
    # (source start file, target name, title, author,
    #  dir menu entry, description, category)
    texinfo_documents = [
        (master_doc, 'tortoise', 'tortoise Documentation',
         author, 'tortoise', 'One line description of project.',
         'Miscellaneous'),
    ]


    # -- Extension configuration -------------------------------------------------
